# The LON-CAPA Homework handler
# Guy Albertelli

package Apache::lonhomework;
use strict;
use Apache::style;
use Apache::lonxml;
use Apache::lonnet;
use Apache::inputtags;
use Apache::structuretags;
use Apache::response;

sub handler {
  my $request=shift;

  my $target=&get_target();
  $request->content_type('text/html');
  $request->send_http_header;
  &Apache::lonhomework::send_header($request);
  my $file = "/home/httpd/html".$request->uri;
  my %mystyle;
  my $result = '';
  &Apache::inputtags::initialize_inputtags;
  $result = Apache::lonxml::xmlparse($target, &getfile($file),
		&getfile('/home/httpd/html/res/adm/includes/default_homework').&setup_vars($target),%mystyle);
  #$request->print("Result follows:");
  $request->print($result);
  #$request->print(":Result ends");
  &Apache::lonhomework::send_footer($request);
}

sub get_target {
  return "web";
}

sub setup_vars {
  my ($target) = @_;
  return ';'
#  return ';$external::target='.$target.';';
}

sub send_header {
  my ($request)= @_;
  $request->print('<html>');
  $request->print('<form method="POST" action="'.$request->uri.'">');
}

sub send_footer {
  my ($request)= @_;
  $request->print('</form>');
  $request->print('</html>');
}

sub getfile {
  my ($filename) = @_;
  my $a="";
  if (! -e $filename ) {
    &Apache::lonnet::subscribe($filename);
    &Apache::lonnet::repcopy($filename);
  }
  {
    my $fh=Apache::File->new($filename);

    while (<$fh>) {
      $a .=$_;
    }
  }
  return $a
}

1;
__END__
